/************************************************************
 * Beauriful, out-of-phase pendulums, the web page animation.
 * Copyright (c) 2011 Petr Sladek (slady)
 * License: CC BY-NC-SA 
 * http://slady.net/
 * http://petr.sladek.name/
 */    

// the pendulums object
pendulums = {
 // pendulums constants
 count: 15,
 firstFrequency: 51,
 // pendulums variables
 positions: [],
 frequencies: [],
 startTime: 0,
 // the pendulums init method
 run: function() {
  var d = 2.0 * Math.PI / 60000.0;
  var h = '';
  var g = '<div class="pendulumsLine"><div class="pendulumsBall"></div></div>';
  // init variables in a loop
  for (var i = 0; i < this.count; i++) {
   this.positions[i] = 0;
   this.frequencies[i] = d * (this.firstFrequency + i);
   h += g;
  }
  // get the starting time
  this.startTime = new Date().getTime();
  // prepare the document
  $("div#pendulumsInner").html(h);
  // start timer
  window.setInterval("pendulums.actualMove()", 30);
 },
 // the pendulums main method, started every 30 milliseconds
 actualMove: function() {
  // get the actual time
  var t = new Date().getTime() - this.startTime;
  // count the positins in a loop
  for (var i = 0; i < this.count; i++) {
   var c = Math.cos(t * this.frequencies[i]);
   this.positions[i] = Math.round(-c * 50 + 50);
  }
  // set div positions
  var pos = this.positions;
  $('div#pendulumsInner div div').css("left", function(i) {
   return " " + (pos[i]) + "%"; });
 }
}

// run the pendulums after the web page will have been loaded
$(document).ready(function() {
 pendulums.run();
});
